/* -*- c -*- */

#ifndef INCLUDE_TTC_H
#define INCLUDE_TTC_H

typedef unsigned char sfnt_tag_t[4] ;

struct sfnt_header {
	uint32_t sctype ;
	uint16_t numtables ;
	uint16_t srange ;
	uint16_t entrysel ;
	uint16_t rangeshift ;
} ;

struct sfnt_table {
	sfnt_tag_t tag ;
	uint32_t csum ;
	uint32_t offset ;
	uint32_t length ;
	uint32_t padded_length ;
	unsigned char * entity ;
} ;

struct sfnt_face_info {
	uint32_t offset ;
	struct sfnt_header header ;
	uint16_t table_capa ;
	int * table_indexes ;
} ;

struct ttc_info {
	uint32_t version ;
	uint32_t face_count ;
	
	uint16_t numtables ;
	
	uint16_t table_capa ;
	struct sfnt_table * tables ;
	
	uint32_t face_capa ;
	struct sfnt_face_info * faces ;
} ;

void read_tag(sfnt_tag_t, unsigned char *) ;
uint32_t read_uint32(unsigned char *) ;
uint16_t read_uint16(unsigned char *) ;
void write_uint32(unsigned char *, uint32_t) ;
void write_uint16(unsigned char *, uint16_t) ;

uint32_t CalcTableChecksum(unsigned char *, uint32_t) ;
struct ttc_info * create_ttc_info(uint32_t) ;

int ttc_find_table_by_offset(struct ttc_info *, sfnt_tag_t, uint32_t) ;
int ttc_find_table(struct ttc_info *, sfnt_tag_t, uint32_t, unsigned char *) ;
int ttc_add_table_direct(struct ttc_info *, sfnt_tag_t, uint32_t, uint32_t, unsigned char *) ;
int ttc_add_table(struct ttc_info *, sfnt_tag_t, uint32_t, unsigned char *) ;
struct ttc_info * ttc_parse_binary(unsigned char *, uint32_t) ;
int ttc_create_face(struct ttc_info *) ;
int ttc_add_table_to_face(struct ttc_info *, int, sfnt_tag_t, uint32_t, unsigned char *) ;

int ttc_write_to_file(struct ttc_info * ttcf, FILE * fp) ;
int ttc_write_face_to_file(struct ttc_info * ttcf, int fidx, FILE * fp) ;


#endif

