
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ttc.h"

int
main(int argc, char ** argv)
{
	int i ;
	int ret ;
	int fd ;
	size_t length ;
	struct stat st ;
	unsigned char * data ;
	struct ttc_info * ttcf ;
	
	if (argc < 2) exit(1) ;
	
	fd = open(argv[1], O_RDONLY) ;
	if (fd < 0) {
		perror("open") ;
		exit(1) ;
	}
	
	ret = fstat(fd, &st) ;
	if (ret < 0) {
		perror("fstat") ;
		exit(1) ;
	}
	
	length = st.st_size ;
	data = mmap(0, length, PROT_READ, MAP_PRIVATE, fd, 0) ;
	if (data == MAP_FAILED) {
		perror("mmap") ;
		exit(1) ;
	}
	
	close(fd) ;
	
	ttcf = ttc_parse_binary(data, length) ;
	if (ttcf == NULL) {
		fprintf(stderr, "parse failed...\n") ;
		exit(1) ;
	}
	munmap(data, length) ;
	
	printf("%d faces\n", ttcf->face_count) ;
	
	for (i=0; i<ttcf->face_count; i++) {
		FILE * fp ;
		char filename[80] ;
		
		snprintf(filename, 80, "face_%02d.ttf", i) ;
		
		fp = fopen(filename, "w") ;
		if (fp == NULL) {
			perror(filename) ;
			exit(2) ;
		}
		
		ttc_write_face_to_file(ttcf, i, fp) ;
		fclose(fp) ;
	}
	
	return 0 ;
}

